"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

import requests as requests_http
from .authentication import Authentication
from .eligibility_apis import EligibilityAPIs
from .offers import Offers
from .orders import Orders
from .payment_links import PaymentLinks
from .payments import Payments
from .pgreconciliation import PGReconciliation
from .refunds import Refunds
from .sdkconfiguration import SDKConfiguration
from .settlement_reconciliation import SettlementReconciliation
from .settlements import Settlements
from .softpos import SoftPOS
from .token_vault import TokenVault
from sdk import utils

class SDK:
    authentication: Authentication
    r"""The Authentication API allows merchants to show a native screen and capture OTP on their own page and submit to Cashfree. This feature is only available on request."""
    eligibility_ap_is: EligibilityAPIs
    offers: Offers
    orders: Orders
    pg_reconciliation: PGReconciliation
    payment_links: PaymentLinks
    payments: Payments
    refunds: Refunds
    settlement_reconciliation: SettlementReconciliation
    settlements: Settlements
    token_vault: TokenVault
    r"""Cashfree's token Vault helps you save cards and tokenize them in a PCI complaint manner. We support creation of network tokens which can be used across acquiring banks"""
    soft_pos: SoftPOS
    r"""softPOS' agent and order management system now supported by APIs"""

    sdk_configuration: SDKConfiguration

    def __init__(self,
                 server_idx: int = None,
                 server_url: str = None,
                 url_params: dict[str, str] = None,
                 client: requests_http.Session = None
                 ) -> None:
        """Instantiates the SDK configuring it with the provided parameters.
        
        :param server_idx: The index of the server to use for all operations
        :type server_idx: int
        :param server_url: The server URL to use for all operations
        :type server_url: str
        :param url_params: Parameters to optionally template the server URL with
        :type url_params: dict[str, str]
        :param client: The requests.Session HTTP client to use for all operations
        :type client: requests_http.Session        
        """
        if client is None:
            client = requests_http.Session()
        
        security_client = client
        
        if server_url is not None:
            if url_params is not None:
                server_url = utils.template_url(server_url, url_params)

        self.sdk_configuration = SDKConfiguration(client, security_client, server_url, server_idx)
       
        self._init_sdks()
    
    def _init_sdks(self):
        self.authentication = Authentication(self.sdk_configuration)
        self.eligibility_ap_is = EligibilityAPIs(self.sdk_configuration)
        self.offers = Offers(self.sdk_configuration)
        self.orders = Orders(self.sdk_configuration)
        self.pg_reconciliation = PGReconciliation(self.sdk_configuration)
        self.payment_links = PaymentLinks(self.sdk_configuration)
        self.payments = Payments(self.sdk_configuration)
        self.refunds = Refunds(self.sdk_configuration)
        self.settlement_reconciliation = SettlementReconciliation(self.sdk_configuration)
        self.settlements = Settlements(self.sdk_configuration)
        self.token_vault = TokenVault(self.sdk_configuration)
        self.soft_pos = SoftPOS(self.sdk_configuration)
    